# If a device needs to provide alternatives version of these .mk files, use
# this project as a submodule called "dgc", and provide your replacement .mk
# files in the root directory of your project.

Name:          droid-glibc
Summary:       Droid components built with glibc
License:       BSD-3-Clause
Version:       1
Group:         System
Release:       1
Source0:       %{name}-%{version}.tar.gz
BuildRequires: droid-src-system
BuildRequires: pkgconfig(zlib)

%description
%{summary}. Environment for building android components to be run on glibc hosts such as imagers.

%package tools
Summary:       Droid glibc Image management tools
Group:         System/Tools
Provides:      droid-hal-tools

%description tools
%{summary}.

%prep
%setup -T -c -n droid-glibc

chown -R abuild:abuild /home/abuild/src/droid/
mv /home/abuild/src/droid/* .
tar -zxf %SOURCE0 # This should extract the rpm/ folder

%build
cd %{name}-%{version}
ANDROID_ROOT=$(readlink -e ..)
# Check if local overrides for tool mk files exist, otherwise dgc defaults are used in Makefile

if test -f simg2img.mk; then
    export SIMG2IMG_MK=$(pwd)/simg2img.mk
fi

if test -f img2simg.mk; then
    export IMG2SIMG_MK=$(pwd)/img2simg.mk
fi

if ! test -f Makefile; then
	cp dgb/Makefile .
fi

# Only build mkbootimg if it's present - on Android 7 it's been replaced with a Python script
if test -f $ANDROID_ROOT/system/core/mkbootimg/mkbootimg.c; then
    export MKBOOTIMG=mkbootimg
    if test -f mkbootimg.mk; then
        export MKBOOTIMG_MK=$(pwd)/mkbootimg.mk
    fi
fi



(make ANDROID_ROOT=$ANDROID_ROOT)

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{_bindir}
# Install tools
if test -f system/core/mkbootimg/mkbootimg; then
	install -m 755 -D system/core/mkbootimg/mkbootimg $RPM_BUILD_ROOT/%{_bindir}/
fi
install -m 755 -D system/core/libsparse/simg2img $RPM_BUILD_ROOT/%{_bindir}/
install -m 755 -D system/core/libsparse/img2simg $RPM_BUILD_ROOT/%{_bindir}/

%files tools
%defattr(-,root,root,-)
%{_bindir}/*
